#region Copyright (c) 2005
/*
{*******************************************************************}
{                                                                   }
{       Copyright (c) 2005                                          }
{		Author: Liewen Huang                                        }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{*******************************************************************}
*/
#endregion
using System;
using System.Collections;

namespace SampleLRM
{
	/// <summary>
	/// The class for the collection of invariant strings.
	/// </summary>
	public class InvariantString : Hashtable
	{
		public InvariantString(string invariantString, string path, string name, string translation, bool isNew)
		{
			ResourcePath pg = new ResourcePath(invariantString, path, name, translation, isNew);
			this[path] = pg;
		}

		public ResourceRow this[string invariantString, string path, string name]
		{
			get
			{
				if (!base.ContainsKey(path))
				{
					ResourceRow entry = null;

					if (base.Count > 0)
					{
						ResourcePath pg;

						foreach (DictionaryEntry de in this)
						{
							pg = (ResourcePath)de.Value;

							foreach (DictionaryEntry de2 in pg)
							{
								entry = (ResourceRow)de2.Value;
								break;
							}

							break;
						}
					}

					// reuse translation if existing.
					if (entry != null)	
						this[path] = new ResourcePath(invariantString, path, name, entry.LocalizedValue, !SampleLRM.WriteUniqueResourceOnly);
					else
						this[path] = new ResourcePath(invariantString, path, name, SampleLRM.ReplaceAltKey(invariantString), true);
				}

				return ((ResourcePath)base[path])[invariantString, path, name];
			}
		}
	}
}
