#region Copyright (c) 2005
/*
{*******************************************************************}
{                                                                   }
{       Copyright (c) 2005                                          }
{		Author: Liewen Huang                                        }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{*******************************************************************}
*/
#endregion
using System;
using System.Collections;

namespace SampleLRM
{
	/// <summary>
	/// Class for the collection of resource file paths.
	/// </summary>
	public class ResourcePath : Hashtable
	{
		private string _path;

		public ResourcePath(string invariantString, string path, string name, string localizedValue, bool isNew)
		{
			_path = path;

			ResourceRow ng = new ResourceRow(invariantString, path, name, localizedValue, isNew);
			this[name] = ng;
		}

		public ResourceRow this[string invariantString, string path, string name]
		{
			get
			{
				if (!base.ContainsKey(name))
				{
					ResourceRow entry = null;

					if (base.Count > 0)
					{
						foreach (DictionaryEntry de in this)
						{
							entry = (ResourceRow)de.Value;
							break;
						}
					}

					// reuse translation if existing for another path.
					if (entry != null)	
						this[name] = new ResourceRow(invariantString, path, name, entry.LocalizedValue, !SampleLRM.WriteUniqueResourceOnly);
					else
						this[name] = new ResourceRow(invariantString, path, name, SampleLRM.ReplaceAltKey(invariantString), true);
				}

				return (ResourceRow)base[name];
			}
		}
	}
}
